"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function () {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _ui() {
  const data = require("@teambit/ui");

  _ui = function () {
    return data;
  };

  return data;
}

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function () {
    return data;
  };

  return data;
}

function _uuid() {
  const data = require("uuid");

  _uuid = function () {
    return data;
  };

  return data;
}

function _notifications() {
  const data = require("@teambit/notifications.notification-context");

  _notifications = function () {
    return data;
  };

  return data;
}

function _notifications2() {
  const data = require("@teambit/notifications.notification-center");

  _notifications2 = function () {
    return data;
  };

  return data;
}

function _notifications3() {
  const data = require("@teambit/notifications.api");

  _notifications3 = function () {
    return data;
  };

  return data;
}

function _notificationReducer() {
  const data = require("./notification-reducer");

  _notificationReducer = function () {
    return data;
  };

  return data;
}

function _notifications4() {
  const data = require("./notifications.aspect");

  _notifications4 = function () {
    return data;
  };

  return data;
}

/**
 * extension
 */
class NotificationUI {
  static provider([uiRuntimeExtension]) {
    return (0, _asyncToGenerator2().default)(function* () {
      return new NotificationUI(uiRuntimeExtension);
    })();
  }

  constructor(uiRuntimeExtension) {
    (0, _defineProperty2().default)(this, "dispatch", void 0);
    (0, _defineProperty2().default)(this, "add", (message, level) => {
      var _this$dispatch;

      const id = (0, _uuid().v1)();
      (_this$dispatch = this.dispatch) === null || _this$dispatch === void 0 ? void 0 : _this$dispatch.call(this, {
        type: 'add',
        content: {
          id,
          message,
          level,
          time: new Date().toISOString()
        }
      });
      return id;
    });
    (0, _defineProperty2().default)(this, "log", message => this.add(message, _notifications3().MessageLevel.info));
    (0, _defineProperty2().default)(this, "warn", message => this.add(message, _notifications3().MessageLevel.warning));
    (0, _defineProperty2().default)(this, "error", message => this.add(message, _notifications3().MessageLevel.error));
    (0, _defineProperty2().default)(this, "success", message => this.add(message, _notifications3().MessageLevel.success));
    (0, _defineProperty2().default)(this, "clear", () => {
      var _this$dispatch2;

      (_this$dispatch2 = this.dispatch) === null || _this$dispatch2 === void 0 ? void 0 : _this$dispatch2.call(this, {
        type: 'clear'
      });
    });
    (0, _defineProperty2().default)(this, "render", props => {
      // this code assumes a single place of render per instance of NotificationUI
      const [messages, dispatch] = (0, _react().useReducer)(_notificationReducer().notificationReducer, []);
      this.dispatch = dispatch;
      return /*#__PURE__*/_react().default.createElement(_notifications2().NotificationCenter, (0, _extends2().default)({}, props, {
        notifications: messages
      }));
    });
    (0, _defineProperty2().default)(this, "renderContext", ({
      children
    }) => {
      return /*#__PURE__*/_react().default.createElement(_notifications().NotificationContext.Provider, {
        value: this
      }, children);
    });
    uiRuntimeExtension.registerHudItem( /*#__PURE__*/_react().default.createElement(this.render, {
      key: "NotificationUI"
    }));
    uiRuntimeExtension.registerContext(this.renderContext);
  }

  /** removes/archives a message from the log */
  dismiss(id) {
    var _this$dispatch3;

    (_this$dispatch3 = this.dispatch) === null || _this$dispatch3 === void 0 ? void 0 : _this$dispatch3.call(this, {
      type: 'dismiss',
      id
    });
  }
  /** adds a message with level "info" to the log */


}

exports.default = NotificationUI;
(0, _defineProperty2().default)(NotificationUI, "dependencies", [_ui().UIAspect]);
(0, _defineProperty2().default)(NotificationUI, "runtime", _ui().UIRuntime);

_notifications4().NotificationsAspect.addRuntime(NotificationUI);

//# sourceMappingURL=notification.ui.runtime.js.map